aboutsummaryrefslogtreecommitdiff
path: root/trunk/src/mkjail
diff options
context:
space:
mode:
Diffstat (limited to 'trunk/src/mkjail')
-rwxr-xr-xtrunk/src/mkjail150
1 files changed, 150 insertions, 0 deletions
diff --git a/trunk/src/mkjail b/trunk/src/mkjail
new file mode 100755
index 0000000..3be3efb
--- /dev/null
+++ b/trunk/src/mkjail
@@ -0,0 +1,150 @@
+#!/bin/bash
+#
+# mkjail v0.4: chroot jail maker
+#
+# feedback: rhatto at riseup.net | GPL
+#
+# Mkjail is free software; you can redistribute it and/or modify it under the
+# terms of the GNU General Public License as published by the Free Software
+# Foundation; either version 2 of the License, or any later version.
+#
+# Mkjail is distributed in the hope that it will be useful, but WITHOUT ANY
+# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+# A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place - Suite 330, Boston, MA 02111-1307, USA
+#
+
+COMMON="/usr/libexec/simplepkg/common.sh"
+BASENAME="`basename $0`"
+
+if [ -f "$COMMON" ]; then
+ source $COMMON
+else
+ echo "error: file $COMMON found, check your `basename $0` installation"
+ exit 1
+fi
+
+function usage {
+
+ echo "usage: [ARCH=arch] [VERSION=version] [ROOT=/otherroot] $BASENAME <jail-name> [template]"
+ exit 1
+
+}
+
+function copy_template_files {
+
+ # copy template files into jail
+ # usage: copy_template_files <jail-path>
+
+ if [ -d "$1" ]; then
+ echo "$BASENAME: copying template files..."
+ if [ -d "$TEMPLATE_BASE.d" ]; then
+ if [ "$TEMPLATES_UNDER_SVN" == "1" ]; then
+ rsync -av --exclude=.svn $TEMPLATE_BASE.d/ $JAIL_ROOT/$server/
+ else
+ rsync -av $TEMPLATE_BASE.d/ $JAIL_ROOT/$server/
+ fi
+ fi
+ fi
+
+}
+
+function set_jail_perms {
+
+ # set template file permissions under a jail
+ # usage: set_jail_perms <jail-path>
+
+ if [ -s "$TEMPLATE_BASE.perms" ]; then
+ cat $TEMPLATE_BASE.perms | while read entry; do
+ file="`echo $entry | cut -d ";" -f 1`"
+ if [ -a "$TEMPLATE_BASE.d/$file" ] && [ -a "$1/$file" ]; then
+ owner="`echo entry | cut -d ";" -f 2`"
+ group="`echo entry | cut -d ";" -f 3`"
+ perms="`echo entry | cut -d ";" -f 4`"
+ chmod $perms $1/$file
+ chown $owner:$group $1/$file
+ fi
+ done
+ fi
+
+}
+
+function exec_post_install_scripts {
+
+ # exec post installation scripts
+ # usage: exec_post_install_script <jail-root> <jail-name>
+
+ if [ -z "$2" ]; then
+ return 1
+ fi
+
+ echo "$BASENAME: executing template scripts..."
+ if [ -d "$TEMPLATE_BASE.s" ]; then
+ for script in `ls $TEMPLATE_BASE.s/`; do
+ if [ -x "$TEMPLATE_BASE.s/$script" ]; then
+ exec $TEMPLATE_BASE.s/$script $1 $2
+ fi
+ done
+ fi
+
+}
+
+function jailist_update {
+
+ # update the jail list file
+ # usage: jailist_update <jail-path>
+
+ if [ -f "$JAIL_LIST" ]; then
+ if ! grep -q "^$1" $JAIL_LIST; then
+ echo $1 >> $JAIL_LIST
+ fi
+ else
+ echo $1 > $JAIL_LIST
+ fi
+
+}
+
+if [ -z "$1" ]; then
+ usage
+else
+ server="$1"
+ eval_config $BASENAME -u
+fi
+
+if [ ! -z "$2" ]; then
+ search_template $2
+ result="$?"
+else
+ result="$?"
+ search_default_template
+fi
+
+if [ "$result" != "0" ]; then
+ exit 1
+fi
+
+TEMPLATE="$TEMPLATE_BASE.template"
+
+if [ ! -d "$JAIL_ROOT/$server" ]; then
+ mkdir -p $JAIL_ROOT/$server
+else
+ if [ ! -z "`ls $JAIL_ROOT/$server | grep -v 'lost+found'`" ]; then
+ echo $BASENAME: error: folder $JAIL_ROOT/$server already exists and seens to be not empty
+ echo $BASENAME: probably the jail $1 already exists
+ exit 1
+ fi
+fi
+
+echo "$BASENAME: instaling packages into $JAIL_ROOT/$server using $TEMPLATE..."
+
+install_packages
+copy_template_files $JAIL_ROOT/$server
+set_jail_perms $JAIL_ROOT/$server
+exec_post_install_scripts $JAIL_ROOT $server
+jailist_update $JAIL_ROOT/$server
+
+echo $BASENAME: done creating $server jail
+